import styles from './index.less';
import {
  useEffect
} from 'react';
import Box from '@/component/box';
import {
  connect
} from 'dva';

function Main({
  dispatch,
  list,
  nowflag,
  actionData,
  winer
}) {


  useEffect(() => {
    if (winer) return // 如果有胜利者就不执行判断胜负方法
    let twoDArry = renderArry(list)
    if (!twoDArry) return
    let reData = checkWin(twoDArry)
    if (reData && reData.status === 'win') {
      dispatch({
        type: "main/updateWinerFn",
        winer: reData.winer
      })
    }

  })

  // 组装二维数组
  function renderArry(dataList) {
    var tempArry = []
    let len = dataList.length
    let n = 3; //假设每行显示3个
    let lineNum = len % 3 === 0 ? len / 3 : Math.floor((len / 3) + 1);
    for (let i = 0; i < lineNum; i++) {
      let temp = dataList.slice(i * n, i * n + n);
      tempArry.push(temp);
    }
    return tempArry
  }
  // 判断输赢
  function checkWin(twoDArry) {
    // 判断第一行
    if (twoDArry[0][0].flag != null && twoDArry[0][1].flag != null && twoDArry[0][2].flag != null && twoDArry[0][0].flag === twoDArry[0][1].flag && twoDArry[0][1].flag === twoDArry[0][2].flag) {
      return {
        status: 'win',
        winer: twoDArry[0][0]
      }
    }
    // 判断第二行
    if (twoDArry[1][0].flag != null && twoDArry[1][1].flag != null && twoDArry[1][2].flag != null && twoDArry[1][0].flag === twoDArry[1][1].flag && twoDArry[1][1].flag === twoDArry[1][2].flag) {
      return {
        status: 'win',
        winer: twoDArry[1][0]
      }
    }
    // 判断第三行
    if (twoDArry[2][0].flag != null && twoDArry[2][1].flag != null && twoDArry[2][2].flag != null && twoDArry[2][0].flag === twoDArry[2][1].flag && twoDArry[2][1].flag === twoDArry[2][2].flag) {
      return {
        status: 'win',
        winer: twoDArry[2][0]
      }
    }
    // 判断第一列
    if (twoDArry[0][0].flag != null && twoDArry[1][0].flag != null && twoDArry[2][0].flag != null && twoDArry[0][0].flag === twoDArry[1][0].flag && twoDArry[1][0].flag === twoDArry[2][0].flag) {
      return {
        status: 'win',
        winer: twoDArry[0][0]
      }
    }
    // 判断第二列
    if (twoDArry[0][1].flag != null && twoDArry[1][1].flag != null && twoDArry[2][1].flag != null && twoDArry[0][1].flag === twoDArry[1][1].flag && twoDArry[1][1].flag === twoDArry[2][1].flag) {
      return {
        status: 'win',
        winer: twoDArry[0][1]
      }
    }
    // 判断第三列
    if (twoDArry[0][2].flag != null && twoDArry[1][2].flag != null && twoDArry[2][2].flag != null && twoDArry[0][2].flag === twoDArry[1][2].flag && twoDArry[1][2].flag === twoDArry[2][2].flag) {
      return {
        status: 'win',
        winer: twoDArry[0][2]
      }
    }
    // 判断交叉左上角到右下角
    if (twoDArry[0][0].flag != null && twoDArry[1][1].flag != null && twoDArry[2][2].flag != null && twoDArry[0][0].flag === twoDArry[1][1].flag && twoDArry[1][1].flag === twoDArry[2][2].flag) {
      return {
        status: 'win',
        winer: twoDArry[0][0]
      }
    }
    // 判断交叉右上角到左下角
    if (twoDArry[0][2].flag != null && twoDArry[1][1].flag != null && twoDArry[2][0].flag != null && twoDArry[0][2].flag === twoDArry[1][1].flag && twoDArry[1][1].flag === twoDArry[2][0].flag) {
      return {
        status: 'win',
        winer: twoDArry[0][2]
      }
    }
  }


  function handleChangeData(flag, key, actionData ) {
    dispatch({
      type: 'main/updateWinerFn',
      winer: null
    })
    dispatch({
      type: 'main/updateRenderDataFn',
      key: key,
      actionData: actionData,
      flag: flag,
    })
  }

  return (
    <div >
      <div className = {styles.content} >
      {
        list.map((item, index) => {
          let colorStr = item.flag === 'X'?'blue':item.flag==='O'?'red':''
          return (
            <Box key = {item.value}
            value = {item.value}
            nowFliage = {nowflag}
            dispatch = {dispatch}
            datasource = {list}
            flag = {item.flag}
            actionData = {actionData}
            winer = {winer}
            color = {colorStr}
            />
          )
        })
      }
      </div>
      <div className = {styles.rightBox} >
        {
          winer ? < p > Winer is {winer.flag} < /p> : <p> Next player: {nowflag }</p>
        }
      <ul>
        <li>
          <button onClick = {() => handleChangeData(true, false, false)} > Go to Game Start < /button>
        </li>
        {
          actionData.map((item, index) => {
            return (
              <li key = {item.key} value = {item.key} >
                <button className = {styles.numLi}
                  onClick = {() => handleChangeData(false, item.key, actionData)} > Go to move# {index+1}
                < /button>
              </li>
            )
          })
        }
        </ul>
    </div>
  </div>
  );
}

function mapStateToProps(state) {
  const {
    nowflag,
    list,
    actionData,
    winer
  } = state.main;
  return {
    nowflag,
    list,
    actionData,
    winer
  };
}

export default connect(mapStateToProps)(Main);
